Subject: bug#10124: 24.0.91; Choosing a remote file, when the current directory is remote too

From: Michael Albinus <[email-masked]>
Date: Tue, 29 Nov 2011 12:08:02 +0100

Michael Albinus <[email-masked]> writes:

> Fortunately, it isn't related to the diff program in use. I could
> reproduce it on a Windows XP machine, using the ftp access
> method, and a GnuWin32 diff.exe:
>
> (executable-find "diff.exe") => "c:/Program Files/GnuWin32/bin/diff.exe"
>
> I'll work on a patch.

Dani, could you, please, check this patch:

--8<---------------cut here---------------start------------->8---
*** /home/albinus/src/emacs/lisp/vc/diff-mode.el.~106543~	2011-11-29 11:43:26.039703592 +0100
--- /home/albinus/src/emacs/lisp/vc/diff-mode.el	2011-11-29 11:42:27.087411264 +0100
***************
*** 815,823 ****
  	    (diff-find-file-name old noprompt (match-string 1)))
         ;; if all else fails, ask the user
         (unless noprompt
!          (let ((file (read-file-name (format "Use file %s: "
!                                              (or (first fs) ""))
!                                      nil (first fs) t (first fs))))
             (set (make-local-variable 'diff-remembered-files-alist)
                  (cons (cons fs file) diff-remembered-files-alist))
             file))))))
--- 815,825 ----
  	    (diff-find-file-name old noprompt (match-string 1)))
         ;; if all else fails, ask the user
         (unless noprompt
!          (let ((file (expand-file-name (or (first fs) "")))
! 	       (default-directory "/"))
! 	   (setq file
! 		 (read-file-name (format "Use file %s: " file)
! 				 nil file t file))
             (set (make-local-variable 'diff-remembered-files-alist)
                  (cons (cons fs file) diff-remembered-files-alist))
             file))))))
--8<---------------cut here---------------end--------------->8---

> Worse: When I check it with a local RHEL5 machine, the test scenario
> from Dani results in
>
> if: Not a Tramp file name:
> /ftp\:slbhao\:/home/albinus/src/tramp/lisp/tramp.el
>
> So we seem to have also a quoting problem. Grrr.

For this one, I'll write a new bug report.

Best regards, Michael.